// PolynomNullstellen.java                          MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Nullstellenberechner fr Polynome mit Newton,
 * Anwendung der Klasse Iteration.
 * @author Monika Meiler
 */
public class PolynomNullstellen
{
/**
 * Hauptprogramm,
 * startet Dialog zwischen Nutzer und Programm.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println();
    System.out.println( "Polynomnullstellen");

// Dialog
    char weiter = 'j';
    do
    {
// Neues Polynom
      System.out.println();
      Polynom p = new Polynom();
      if( p.konsolenEingabe())           // Eingabe korrekt
      {
// Polynomausgabe
        System.out.println();
        System.out.println( "p( x) = " + p);
        System.out.println();

        do
        {
// Eingabe der Startnullstelle
          double x0
          = IOTools.readDouble( " Anfangswert x0 = ");
          System.out.println( " " + x0);

          double eps = 1e-15;                // Genauigkeit
          int max = 1000;    // Maximalzahl der Iterationen

// Newtoniteration
          Iteration it = new Iteration();
          double erg = it.newton( p, x0, eps, max);

          int anzahl = it.getAnzahl();
          if( anzahl == max) System.out.println
            ( " Berechnung vorzeitig abgebrochen!" + 
              " Ergebnis ungenau!");

          System.out.println
          ( " Newton (" + anzahl + "): " + erg);
          System.out.println();

// Weiter
          weiter = IOTools.readChar
                   ( "Neuer Anfangswert (j/n)? ");
        } while( weiter == 'j');
      }

      System.out.println();
      weiter = IOTools.readChar( "Neues Polynom (j/n)? ");
      System.out.println();
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
                                           // Testbeispiele
/*
Betrachte -3.0 + 7.0 x^1 + -5.0 x^2 + 1.0 x^3 =
          (x-3)(1.0 + -2.0 x^1 + 1.0 x^2)=
          (x-3)(x-1)(x-1)

Polynomnullstellen

p( x) = -3.0 + 7.0 x^1 + -5.0 x^2 + 1.0 x^3
 Anfangswert x0 =  4.0
 Newton (6): 3.0

 Anfangswert x0 =  1.0
 Newton (0): 1.0

p( x) = 1.0 + -2.0 x^1 + 1.0 x^2
 Anfangswert x0 =  1.0
 Newton (0): 1.0

 Anfangswert x0 =  2.0
 Newton (25): 1.0000000298023224

 Anfangswert x0 =  3.0
 Newton (26): 1.0000000298023224

p( x) = 0.0 + -2.0 x^1 + 1.0 x^2
 Anfangswert x0 =  1.0
 Berechnung vorzeitig abgebrochen! Ergebnis ungenau!
 Newton (1000): Infinity

 Anfangswert x0 =  0.5
 Newton (6): -5.9164567891575885E-31

 Anfangswert x0 =  2.0
 Newton (0): 2.0

 Anfangswert x0 =  3.0
 Newton (6): 2.0

p( x) = 2.0 + -2.0 x^1 + 1.0 x^2
 Anfangswert x0 =  1.0
 Newton (0): -Infinity

 Anfangswert x0 =  2.0
 Newton (1): -Infinity

 Anfangswert x0 =  3.0
 Berechnung vorzeitig abgebrochen! Ergebnis ungenau!
 Newton (1000): -1.390804467448622
*/
