// Power.java                                       MM 2013
import Tools.IO.*;

/**
 * Potenzfunktion f(x) = a ^ x,
 * Basis a aus R, a > 0, a >< 1, D = R, W = ] 0, +unendlich[.
 * @author Monika Meiler
 */
public class Power extends DifferenzierbareFunktion
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Basis a.
 */
  private double a = 2;

/* ----------------------------------------------------- */
                                             // set-Methode
/**
 * Setzt a fuer a ^ x.
 * @param basis Basis a
 * @return true, bei erfolgreichem Eintrag
 *         false, a <= 0 oder a == 1
 */
  public boolean setBasis( double basis)
  {
    if( a <= 0 || a == 1) return false;
    a = basis;
    return true;
  }

/**
 * Basiseingabe ueber Konsole.
 * @return true, bei erfolgreichem Eintrag
 *         false, a <= 0 oder a == 1
 */
  public boolean konsolenEingabe()
  {
// Eingabe der Geradenkoeffizienten
    System.out.println( "Basiseingabe");
    double a = IOTools.readDouble
       ( " Basis a ( a > 0, a >< 1) = ");

    return setBasis( a);
  }

/* ----------------------------------------------------- */
                                         // service-Methode
/**
 * Berechnen eines Funktionswertes der Funktion
 * a ^ x = e ^ (x * ln( a)).
 * @param arg Argument
 * @return f( arg)
 */
  public double wert( double arg)
  {
    if( arg == 0) return 1;

    Exp e = new Exp();
    Ln ln = new Ln();

    return e.wert( arg * ln.wert( a));
  }

/**
 * Berechnen einer ersten Ableitung
 * f'(x) = a ^ x * ln( a).
 * @param arg Argument
 * @return f'( arg)
 */
  public double wertErsteAbleitung( double arg)
  {
    Ln ln = new Ln();
    return wert( arg) * ln.wert( a);
  }

/* ----------------------------------------------------- */
                                        // toString-Methode
/**
 * Darstellen der Funktion.
 * @return Funktion in linearer Schreibweise
 */
  public String toString()
  {
    return "" + a + " ^ x";
  }
}